/// A simple wrapper for OpenGL materials. Lets you set things such as the "shininess" of your elements.

#include <Color4.hpp>
#include <glad/glad.h>
namespace JGL {
    class Material;
}
class JGL::Material {
public:
    Color4 ambient_ref;
    Color4 diffuse_ref;
    Color4 specular_ref;
    Color4 emission;
    float shininess;
public:
    Material(const Color4& ambient_reflection, const Color4& diffuse_reflection, const Color4& specular_reflection, const Color4& light_emission, float& shine);
    /// @param material Material to use.
    static void SetActiveMaterial(const Material& material);
};