#include <JGL/JGL.h>

void JGL::ShapeCache::Init() {
    std::array<Vector3, 8> vertices = {
            Vector3(1.0f,  1.0f, -1.0f),
            Vector3(1.0f, -1.0f, -1.0f),
            Vector3(1.0f,  1.0f,  1.0f),
            Vector3(1.0f, -1.0f,  1.0f),
            Vector3(-1.0f,  1.0f, -1.0f),
            Vector3(-1.0f, -1.0f, -1.0f),
            Vector3(-1.0f,  1.0f,  1.0f),
            Vector3(-1.0f, -1.0f,  1.0f)
    };
    std::array<unsigned int, 36> indices = {
            4, 2, 0,
            2, 7, 3,
            6, 5, 7,
            1, 7, 5,
            0, 3, 1,
            4, 1, 5,
            4, 6, 2,
            2, 6, 7,
            6, 4, 5,
            1, 3, 7,
            0, 2, 3,
            4, 0, 1
    };

    std::array<Vector3, 8> vertex_normals = {
            Vector3( 0.816f,  0.408f, -0.408f),
            Vector3( 0.333f, -0.667f, -0.667f),
            Vector3( 0.333f,  0.667f,  0.667f),
            Vector3( 0.816f, -0.408f,  0.408f),
            Vector3(-0.333f,  0.667f, -0.667f),
            Vector3(-0.816f, -0.408f, -0.408f),
            Vector3(-0.816f,  0.408f,  0.408f),
            Vector3(-0.333f, -0.667f,  0.667f)
    };

    if (!cube_vertex_data)
        cube_vertex_data = new VRamList(vertices.data(), vertices.size());

    if (!cube_index_data)
        cube_index_data = new VRamList(indices.data(), indices.size());

    if (!cube_normal_data)
        cube_normal_data = new VRamList(vertex_normals.data(), vertex_normals.size());

    if (!square_origin_topleft_vertex_data) {
        std::array<Vector2, 4> square_vertices = { Vector2(0, 0), {1, 0}, {1, -1}, {0, -1} };
        square_origin_topleft_vertex_data = new VRamList(square_vertices.data(), square_vertices.size());
    }
    if (!j2d_default_normal_data) {
        std::array<GLfloat, 3> normal {0, 0, 1};
        j2d_default_normal_data = new VRamList(normal.data(), normal.size());
    }
}